package com.zuitt;

import java.io.IOException;
import java.io.PrintWriter;

import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

public class CalculatorServlet extends HttpServlet {

	/*
	* Can be generated by hovering on the CalculatorServlet class above and selecting the option
	* "Add generated serialVersionUID"
	* The serialVersionUID attribute is an identifier used to serialize/deserialize an object of a
	* Serializable class which is inherited from HttpServlet
	* Serializing is the conversion of data into a byte stream that can be reverted back into a copy
	* of an object through deserialization
	*/
	private static final long serialVersionUID = 2980023588801386102L;

	/*
	* The HttpServletRequest and HttpServletResponse objects should be imported from the jakarta 
	* package which is the java enterprise edition package
	* By default form requests are sent as "GET" requests when the method is not specified
	* Changing the method name to "doPost" ensure that this will only be accessed via a "POST" request
	*/
	public void doPost(HttpServletRequest req, HttpServletResponse res) throws IOException {
		
		/*
		* Unlike in intelliJ IDE typing "sout" and pressing on the "tab" key will not automatically
		* generate the code for printing a message in the console
		*/
		System.out.println("Hello from the calculator servlet");
		
		/*
		* The parameter names are defined in the form input field
		* Strings are the default data types produced by the "getParameter" method
		* The parameters are found in the url as a query string (e.g. ?num1=&num2=)
		*/
		int num1 = Integer.parseInt(req.getParameter("num1"));
		int num2 = Integer.parseInt(req.getParameter("num2"));
		
		int total = num1 + num2;
		
		/*
		* The "getWriter" method is used to print out information in the browser
		* The getWriter method may throw an IOException and must be specified in the method
		*/
		PrintWriter out = res.getWriter();
		
		// prints a string in the browser
		// out.println("The total of the two numbers are: " + total);
		out.println("<p> The total of the two numbers are: " + total + "</p>");
		
	}
	
	public void doGet(HttpServletRequest req, HttpServletResponse res) throws IOException {
		
		PrintWriter out = res.getWriter();
		out.println("<h1>You have accessed the get method of the calculator servlet</h1>");
		
	}
	
	private String contentType;
	
	/*
	* Servlet Lifecycle
	* The first part of the servlet lifecycle is the initialization
	* If an instance of the servlet does not exist, the web container does the following
	* - loads the servlet class
	* - creates an instance of the servlet class
	* - initializes the servlet instance by calling the "init" method
	* The "init" method can also be used to perform other functions such as connecting to a
	* database or initializing values to be used in the context of the servlet
	*/
	public void init() throws ServletException {
		
		contentType = "text/html";
		
		System.out.println("****************************************");
		System.out.println(" Initialized connection to DB ");
		System.out.println("****************************************");
	}
	
	/*
	* The second part of the lifecycle invokes the service methods, passing request and 
	* response objects
	* These methods can be invoked more than once to handle requests
	* Having both a "service" method and a "doGet" method will cause problems since the get
	* request is also mapped to the "service" method
	* Using the "doGet" and "doPost" methods are appropriate for creating servlet
	* methods
	*/
	public void service(HttpServletRequest req, HttpServletResponse res) throws IOException, ServletException {
		System.out.println(" Currently connected to Employee DB");
		
		PrintWriter out = res.getWriter();
		out.println("<h1>You are now connected to the Database</h1>");
	}
	
	/*
	* The last part of the lifecycle is finalizing the servlet by invoking the "destroy"
	* method and can also be used to perform other functions such as
	* disconnecting to a database
	*/
	public void destroy() {
		System.out.println("****************************************");
		System.out.println(" Disconnected from DB ");
		System.out.println("****************************************");
	}
}
